<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="search-form" :label-width="80" v-show="searchOpen" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="试样编号:">
                <Input @on-enter="_formSearch" v-model="formObj.sampleCode" name="sampleCode" placeholder="请输入试样编号" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <Col span="24">
            <btn-list :msg="btn" :open="searchOpen" @on-result-change="_btnClick" :showSearchBtn="true"
                     class="contHide">
            </btn-list>
          </Col>
          <!--样品数量-->
          <!-- 表格 -->
          <Col span="24">
            <PTVXETableHeight ref="pageTable" :table-height="tableHeight" :loading="true"
                              :get-page="getPage" @on-result-change="_tableResultChange" select-data>
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}</span>
                  <div v-else-if="item.key==='keepContainer'">
                    <div v-if="editIndex!==scope.rowIndex">{{scope.row[item.key]}}</div>
                    <div v-else>
                      <AutoCompletes v-model="scope.row.keepContainer" :downData="containerList"
                                    @on-result-change="_containerChange" name="keepContainer"  placeholder="输入或选择保存容器"
                      ></AutoCompletes>
                    </div>
                  </div>
                  <div v-else-if="item.key==='quantity'">
                    <div v-if="editIndex!==scope.rowIndex">{{scope.row[item.key]}}</div>
                    <div v-else>
                      <el-input v-model="scope.row.quantity" placeholder="制备数量"></el-input>
                    </div>
                  </div>
                  <div v-else-if="item.key==='keepLocation'">
                    <div v-if="editIndex!==scope.rowIndex">{{scope.row[item.key]}}</div>
                    <div v-else>
                      <el-input v-model="scope.row.keepLocation" placeholder="留存位置"></el-input>
                    </div>
                  </div>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
              <vxe-table-column
                slot="col"
                :width="80"
                title="操作"
                align="center"
                fixed="right">
                <template slot-scope="scope">
                  <VXEIconList :msg="editIndex===scope.rowIndex?iconMsgSave:iconMsg" @on-result-change="_iconClick" :rowData="scope.row" :rowIndex="scope.rowIndex"></VXEIconList>
                </template>
              </vxe-table-column>
            </PTVXETableHeight>
          </Col>
        </Row>
      </div>
    </div>
    <SampleParpareApply ref="applyModal" @on-result-change="_page"></SampleParpareApply>
    <Operation ref="recordModal"></Operation>
    <SampleSurplusBatchEdit ref="batchEdit" @on-result-change="_page"></SampleSurplusBatchEdit>
  </div>
</template>
<script>
import SampleParpareApply from '../SurplusParpareApply'
import SampleSurplusBatchEdit from '../SampleSurplusBatchEdit'
// eslint-disable-next-line no-unused-vars
import http from '../../../../api/http'
import { soilSample } from '../../../../api'
import Operation from '../../../../components/operation/Operation'
import AutoCompletes from '../../../../components/base/AutoCompletes'
export default {
  components: {
    SampleParpareApply,
    Operation,
    SampleSurplusBatchEdit,
    AutoCompletes
  },
  data() {
    return {
      currentComponent: '',
      searchOpen: false,
      formObj: {},
      selectData: [],
      selectIds: [],
      indexList: [],
      selectSampleIds: [],
      getPage: {},
      btn: [
        {
          type: 'primary',
          id: 'surplus-apply-dispose',
          name: '申请处理'
        },
        {
          type: 'primary',
          id: 'surplus-finish-dispose',
          name: '完成处理'
        },
        {
          type: 'primary',
          id: 'surplus-batch-input',
          name: '批量填写存放信息'
        }
        // { type: '', id: '', name: '填写存放信息' },
        // { type: '', id: '', name: '申请处理' },
        // { type: '', id: '', name: '导出' },
      ],
      iconMsg: [
        { type: 'md-create', id: 'surplus-edit', name: '编辑' }, // food-sample-prepare-edit
        { type: 'ios-clock', id: 'surplus-record', name: '操作日志' }
      ],
      iconMsgSave: [
        { type: 'ios-checkmark', id: 'surplus-save', name: '保存' }
      ],
      pageColumns: [
        { title: '试样编号', key: 'sampleCode', width: 150 },
        { title: '状态', key: 'status', status: true, width: 100 },
        { title: '包装类型', key: 'samplePack', width: 100 },
        { title: '保存容器', key: 'keepContainer', width: 150 },
        { title: '留存位置', key: 'keepLocation', width: 150 },
        { title: '制备数量', key: 'quantity', width: 100 },
        { title: '单位', key: 'unit', width: 70 },
        { title: '制备人', key: 'preparer', width: 130 },
        { title: '制备时间', key: 'prepareDate', date: true, width: 130 }
        // { title: '备注', key: 'remark', width: 130 }
        /*  {title: '处置方式', key: 'handleMethod', width: 120,}, */
      ],
      conditionList: [],
      locList: [],
      containerList: [],
      currentIndex: -1,
      editIndex: -1,
      endDateBegin: '',
      endDateEnd: '',
      // 只看预警和超期样品
      warnAndOver: 0,
      sampleHandleValue: '',
      issueDateBegin: '',
      issueDateEnd: '',
      isEligible: ''
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('', 255)
      } else {
        return this.$tableHeight('', 220)
      }
    },
    colorComputed() {
      return function(date) {
        if (this.$warningValue(date) < 0) {
          return '#eb6877' // 红色
        } else if (
          this.$warningValue(date) >= 0 &&
          this.$warningValue(date) <= this.sampleHandleValue
        ) {
          return '#f90' // 橙色
        }
      }
    }
  },
  mounted() {
    this.$refs.pageTable._showLoading()
    this._getContainerList()
  },
  methods: {
    // 签发日期
    _issueDateChange(date) {
      this.issueDateBegin = date[0]
      this.issueDateEnd = date[1]
    },
    // 重新请求page以及备样数量
    _relPage() {
      this._page()
      // this._getBackUpCount()
    },
    _getContainerList: async function() {
      const result = await soilSample.getDictList('保存容器')
      if (result) {
        for (let i = 0; i < result.length; i++) {
          this.containerList.push(result[i].name)
        }
      }
    },
    _containerChange(msg, data) {
      switch (msg) {
        case 'select':
          this.getPage.records[this.currentIndex].keepContainer = data
          break
        case 'query':
          this.getPage.records[this.currentIndex].keepContainer = data
          break
      }
    },
    // 选择时间
    _endDateChange(data) {
      this.getPage.records[this.currentIndex].endDate = data
    },
    // 查询-接收日期
    _dateChange(data) {
      this.endDateBegin = data[0]
      this.endDateEnd = data[1]
    },
    _save() {
      this.$nextTick(function() {
        const tempData = {
          keepContainer: this.getPage.records[this.currentIndex].keepContainer,
          quantity: this.getPage.records[this.currentIndex].quantity,
          keepLocation: this.getPage.records[this.currentIndex].keepLocation
        }
        this._saveOk({
          id: this.getPage.records[this.currentIndex].id,
          obj: tempData
        })
      })
    },
    _saveOk: async function(data) {
      console.log(data)
      const result = await soilSample.editPrepare(data)
      if (result) {
        this.$Message.success('编辑成功')
      }
    },
    _iconClick(res, data, componentName, index) {
      this.currentIndex = index
      switch (res) {
        case '操作日志':
          this._record(data.id)
          break
        case '编辑':
          this.editIndex = index
          break
        case '保存':
          console.log('保存')
          // if (data.endDate !== '') {
          //   // 非空情况下格式化赋值，如果不判断会格式化为当天的日期
          //   this._endDateChange(this.$dateformat(data.endDate, 'yyyy-mm-dd'))
          // }
          this._save()
          this.editIndex = -1
          break
      }
    },
    _record(id) {
      this.$refs.recordModal._openSurplus(id)
    },
    // 操作的序号
    _handleIndex(data) {
      this.currentIndex = data.rowIndex
    },
    _btnClick(msg) {
      switch (msg) {
        case '申请处理':
          this._applyDispose()
          break
        case '完成处理':
          this._handleApply()
          break
        case '制备':
          this._preMethod()
          break
        case '无需制备':
          this._noPreMethod()
          break
        case '扫码制备':
          this._scanPreMethod()
          break
        case '填写存放信息':
          this._batchEdit()
          break
        case '批量填写存放信息':
          this._writeInfo()
          break
        case '导出':
          if (this.getPage.records.length === 0) {
            this.$Message.warning('暂无数据，不可导出')
          } else {
            this._export()
          }
          break
        case '导出备样记录':
          this._exportReceiveRecord()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _writeInfo() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.batchEdit._open(this.selectIds)
      }
    },
    _resultChange(msg) {
      this.$Message.success(msg)
      this._page()
    },
    _applyDispose() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.applyModal._open(this.selectIds)
      }
    },
    _handleApply() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        console.log(this.selectData)
        const errorIds = []
        for (let i = 0; i < this.selectIds.length; i++) {
          if (this.selectData[i].status.display !== '处理审批通过') {
            errorIds.push(this.selectData[i].index + 1)
          }
        }
        if (errorIds.length === 0) {
          this.$Modal.confirm({
            title: '提示',
            content: '确定处理这 ' + this.selectIds.length + ' 条数据？',
            onOk: () => {
              this._handleOk(this.selectIds.join(','))
            }
          })
        } else {
          // this.$Message.warning('第 ' + errorIds + ' 条数据的审批未通过')
          this.$notify({
            title: '提示',
            message: '第 ' + errorIds + ' 行数据的审批未通过',
            duration: 4000,
            type: 'error'
          })
        }
      }
    },
    _handleOk: async function() {
      const result = await soilSample.surplusHandleOk({
        ids: this.selectIds.join(',')
      })
      if (result) {
        this._resultChange('提交成功')
      }
    },
    // 制备
    _preMethod() {
      if (this.selectSampleIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.preModal._open(this.selectSampleIds)
      }
    },
    // 无需制备
    _noPreMethod() {
      if (this.selectSampleIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.noPreModal._open(this.selectSampleIds)
      }
    },
    _scanPreMethod() {
      this.$refs.scanPreModal._open()
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectData':
          this.selectData = data
          this.selectIds = []
          this.selectSampleIds = []
          for (let i = 0; i < data.length; i++) {
            this.selectIds.push(data[i].id)
            this.selectSampleIds.push(data[i].sampleId)
          }
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    allSelect(data) {
      this.indexList = []
      for (let i = 0; i < data.length; i++) {
        this.indexList.push(data[i])
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
      // this._getBackUpCount()
    },
    _page: async function() {
      this.editIndex = -1
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await soilSample.pageSurplus(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _batchEdit() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.editModal._open(this.selectData)
      }
    },
    _handle() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.applyModal._open(this.selectData)
      }
    },
    // 参数
    _searchParams() {
      const data = this.$serialize('search-form')
      return this.$extend(data, { page: 1, rows: 5000 })
    }
    /** *********************************导出样品台账-end*********************************************/
  }
}
</script>
<style scoped>
/******副样、备样卡片********/
.reimbursement-item {
  flex: 1;
  border-radius: 5px;
  border: 1px solid #e8e8e8;
  padding-bottom: 10px;
}

.reimbursement-item + .reimbursement-item {
  margin-left: 20px;
}

.reimbursement-item p {
  text-align: center;
  margin: 0;
}

.reimbursement-item > p:first-child {
  font-size: 22px;
  line-height: 40px;
}
</style>
